#include <csignal>
#include <iostream>
#include <sstream>
#include <socketstream/iostream.h>
#include <socketstream/address.h>
#include <irc_msg.h>

// Call exit() on SIGINT to help on profiling
void
signal_interrupt (int signal)
{
  exit(0);
}

int main (int argc, char** argv)
{
  try
  {
    std::signal(SIGINT, signal_interrupt);
    socketstream::iosocketstream conn;
    {
      socketstream::inet_address addr(argv[1], "ircd");
      conn.open(addr);
    }
    conn << "USER thoth * * :Pedro Lamarao\r\n";
    conn << "NICK sockets_app_irc\r\n" << std::flush;
    if (argc > 2)
    {
      std::stringstream s;
      s << "JOIN " << argv[2] << "\r\n";
      conn << s.str();
      s << "PRIVMSG " << argv[2] << " :I'm alive!" << "\r\n";
      conn << s.str() << std::flush;
    }
    irc_msg msg;
    while (conn >> msg)
    {
      std::cout << msg << std::flush;
    }
    return 0;
  }
  catch (const std::exception& e)
  {
    std::cerr << "Exception caught: " << e.what() << std::endl;
    return -1;
  }
}
