#include "get_listener.h"

socketstream::listener& get_listener (int argc, char** argv, char* service)
{
  socketstream::listener* listener;
  socketstream::address*  addr;
  char c = getopt(argc, argv, "46l");
  if (c == '6')
  {
    listener = new socketstream::listener(socketstream::sockets_base::inet6);
    addr = new socketstream::inet6_address(0, service);
  }
  else if (c == 'l')
  {
    listener = new socketstream::listener(socketstream::sockets_base::local);
    addr = new socketstream::local_address("./service.sock");
  }
  else
  {
    listener = new socketstream::listener(socketstream::sockets_base::inet);
    addr = new socketstream::inet_address(0, service);
  }
  listener->bind(*addr);
  delete addr;
  return *listener;
}
