// -*- Socket Streams -*-

// Copyright (C) 2003 Pedro Lamarao <pedro.lamarao@izcom.com.br>

// This file is part of the Socket Streams Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU Lesser General Public License as published by the
// Free Software Foundation; either version 2.1 of the License
// or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License along
// with this library; see the file COPYING. If not, write to the Free
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// USA

/** @file socket_exception.cc
 * @doctodo
 */

#include <socketstream/socket_exception.h>
#include <cerrno>

namespace socketstream {

  socket_exception::socket_exception () throw ()
  : _M_code(errno)
  {	_M_msg = strerror(_M_code); }

  socket_exception::socket_exception (int __code) throw ()
  : _M_code(__code)
  {	_M_msg = strerror(_M_code); }

  const char*
  socket_exception::what () const throw ()
  { return _M_msg.c_str(); }
  
  int
  socket_exception::code () const throw ()
  {	return _M_code; }
}
