#include <cstring>
#include <iostream>
#include <exception>
#include <socketstream/basic_socket.h>
#include <socketstream/inet_factory.h>

const char* msg = "Hello World!";
const int msgsize = 12;
const int bufsize = 24;

// Tests I/O on a default constructed basic_socket.

int main (int argc, char** argv)
{
  try
  {
    socketstream::inet_address addr(0, "echo");
    socketstream::basic_socket sock;
    sock.connect(addr);

    std::cout << "sending: \"" << msg << "\"" << std::endl;
    sock.send(msg, msgsize);

    char buffer[bufsize] = "";
    sock.receive(buffer, bufsize);
    std::cout << "received: \"" << buffer << "\"" << std::endl;

    int ret = std::memcmp(buffer, msg, msgsize);
    sock.shutdown(socketstream::sockets_base::rw);
    return ret;
  }
  catch (const std::exception& e)
  {
    std::cerr << "Exception caught: " << e.what() << std::endl;
    return -1;
  }
}
