#include <cstring>
#include <iostream>
#include <exception>
#include <socketstream/basic_socketbuf.h>
#include <socketstream/inet_factory.h>

const char* msg = "Hello World!";
const int msgsize = 12;
const int bufsize = 24;

// Tests I/O on a default constructed basic_socketbuf,
// using sputn() for output, sbumpc() for input.

int main (int argc, char** argv)
{
  try
  {
    socketstream::inet_address addr(0, "echo");
    socketstream::basic_socketbuf<char, std::char_traits<char> > sock;
    sock.open(addr);

    std::cout << "sending: \"" << msg << "\"" << std::endl;
    sock.sputn(msg, msgsize);
    sock.pubsync();

    char buffer[bufsize] = "";
    int i = 0;
    for (int i = 0; i < msgsize; i++)
      buffer[i] = sock.sbumpc();
    std::cout << "received: \"" << buffer << "\"" << std::endl;

    int ret = std::memcmp(buffer, msg, msgsize);
    sock.shutdown(socketstream::sockets_base::rw);
    return ret;
  }
  catch (const std::exception& e)
  {
    std::cerr << "Exception caught: " << e.what() << std::endl;
    return -1;
  }
}
