#include <cstring>
#include <iostream>
#include <socketstream/basic_socketbuf.h>
#include <socketstream/inet_factory.h>

const char* msg = "Hello World!";
const int msgsize = 12;
const int bufsize = 24;

// Tests I/O on a basic_socketbuf(const basic_socket&),
// using sputn() for output, sgetn() for input.

int main (int argc, char** argv)
{
  try
  {
    socketstream::inet_address addr(0, "echo");
    socketstream::basic_socket s;
    s.connect(addr);
    socketstream::basic_socketbuf<char, std::char_traits<char> > sock(s);

    std::cout << "sending: \"" << msg << "\"" << std::endl;
    sock.sputn(msg, msgsize);
    sock.pubsync();

    char buffer[bufsize] = "";
    sock.sgetn(buffer, msgsize);
    std::cout << "received: \"" << buffer << "\"" << std::endl;

    int ret = std::memcmp(buffer, msg, msgsize);
    sock.shutdown(socketstream::sockets_base::rw);
    return ret;
  }
  catch (const std::exception& e)
  {
    std::cerr << "Exception caught: " << e.what() << std::endl;
    return -1;
  }
}
