#include <cstring>
#include <iostream>
#include <socketstream/basic_socket.h>
#include <socketstream/basic_osocketstream.h>
#include <socketstream/inet_factory.h>

const char* msg = "Hello World!";
const int msgsize = 12;
const int bufsize = 24;

// Tests I/O on a default constructed basic_osocketstream,
// with basic_socket::receive() for input.

int main (int argc, char** argv)
{
  try
  {
    socketstream::inet_address addr(0, "echo");
    socketstream::osocketstream os;
    os.open(addr);
    socketstream::basic_socket &sock = reinterpret_cast<socketstream::basic_socketbuf<char, std::char_traits<char> > *>(os.rdbuf())->socket();

    std::cout << "sending: \"" << msg << "\"" << std::endl;
    os << msg << std::flush;

    char buffer[bufsize] = "";
    sock.receive(buffer, msgsize);
    std::cout << "received: \"" << buffer << "\"" << std::endl;

    int ret = std::memcmp(buffer, msg, msgsize);
    os.shutdown(socketstream::sockets_base::rw);
    return ret;
  }
  catch (const std::exception& e)
  {
    std::cerr << "Exception caught: " << e.what() << std::endl;
    return -1;
  }
}
