#include <cstring>
#include <iostream>
#include <socketstream/basic_socket.h>
#include <socketstream/basic_osocketstream.h>
#include <socketstream/inet_factory.h>

const char* msg = "Hello World!";
const int msgsize = 12;
const int bufsize = 24;

using namespace std;
using namespace socketstream;

// Tests I/O on a basic_osocketstream(const basic_socket&),
// with basic_socket::receive() for input.

int main (int argc, char** argv)
{
  try
  {
    socketstream::inet_address addr(0, "echo");
    socketstream::basic_socket s;
    s.connect(addr);
    socketstream::osocketstream os(s);

    std::cout << "sending: \"" << msg << "\"" << std::endl;
    os << msg << std::flush;

    char buffer[bufsize] = "";
    s.receive(buffer, msgsize);
    std::cout << "received: \"" << buffer << "\"" << std::endl;

    int ret = memcmp(buffer, msg, msgsize);
    os.shutdown(socketstream::sockets_base::rw);
    return ret;
  }
  catch (const std::exception& e)
  {
    std::cerr << "Exception caught: " << e.what() << std::endl;
    return -1;
  }
}
