#include <cstring>
#include <iostream>
#include <socketstream/basic_socket.h>
#include <socketstream/basic_isocketstream.h>
#include <socketstream/inet_factory.h>

const char* msg = "Hello World!";
const int msgsize = 12;
const int bufsize = 24;

// Tests I/O on a basic_isocketstream(const basic_socket&),
// with basic_socket::send() for output,
// get(char*,streamsize) for input.

int main (int argc, char** argv)
{
  try
  {
    socketstream::inet_address addr(0, "echo");
    socketstream::basic_socket sock;
    sock.connect(addr);
    socketstream::isocketstream is(sock);

    std::cout << "sending: \"" << msg << "\"" << std::endl;
    sock.send(msg, msgsize);
    char eof = std::char_traits<char>::eof();
    sock.send(&eof, 1);

    char buffer[bufsize] = "";
    is.get(buffer, msgsize + 1);
    std::cout << "received: \"" << buffer << "\"" << std::endl;

    int ret = std::memcmp(buffer, msg, msgsize);
    sock.shutdown(socketstream::sockets_base::rw);
    return ret;
  }
  catch (const std::exception& e)
  {
    std::cerr << "Exception caught: " << e.what() << std::endl;
    return -1;
  }
}
