#include <cstring>
#include <iostream>
#include <exception>
#include <socketstream/basic_iosocketstream.h>
#include <socketstream/inet_factory.h>

const char* msg = "Hello World!";
const int msgsize = 12;
const int bufsize = 24;

// Tests I/O on a default constructed basic_iosocketstream,
// with operator<< for output, get(char*,streamsize) for input.

int main (int argc, char** argv)
{
  try
  {
    socketstream::inet_address addr(0, "echo");
    socketstream::iosocketstream sock;
    sock.open(addr);

    std::cout << "sending: \"" << msg << "\"" << std::endl;
    sock << msg << std::endl; // let's send a delimiter \o/

    char buffer[bufsize] = "";
    sock.get(buffer, bufsize); // will stop at delimiter '\n'
    std::cout << "received: \"" << buffer << "\"" << std::endl;

    int ret = std::memcmp(buffer, msg, msgsize);
    sock.shutdown(socketstream::sockets_base::rw);
    return ret;
  }
  catch (const std::exception& e)
  {
    std::cerr << "Exception caught: " << e.what() << std::endl;
    return -1;
  }
}
